<?php

// initialized after configuration, before dispatch

// ** configuration should have a chance to influence all of these before they are set here -- needs to be checked.

/*

	$repository

		roots

			localroot

			farmroot

			domainroot

		publicresources // pub/

			(resource) localpublic

			(resource) farmpublic

		publicfiles // uploads/

			(resource) uploads

*/

class ObjectWiki

{

	private static $_instance = NULL;

	

	private $_selected_framework;

	

	public static function instance()
	{
		if (!self::$_instance)
		{

			self::$_instance = new self();
		}

		return self::$_instance;
	}



	private $_repository;



	protected function __construct()

	{

	}

	

	public function prepare_ObjectWiki()

	{

		$this->_repository = $repository = new Repository();

		$pmwiki = PMW_PmWiki::instance();

		// roots

		// ** include domain path in search list?

		$roots = new Repository();

		$roots->set_location($pmwiki->get_localdir());

		$roots->set_url($pmwiki->get_localurl());

		$roots->set_location($pmwiki->get_farmdir());

		// ... no url for farmdir - not public

		$repository->set_repository('roots',$roots);



		// localroot

		$rlocal = new Repository();

		$rlocal->set_location($pmwiki->get_localdir());

		$rlocal->set_url($pmwiki->get_localurl());

		$roots->set_repository('localroot',$rlocal);

		

		// farmroot

		$rfarm = new Repository();

		$rfarm->set_location($pmwiki->get_farmdir());

		$roots->set_repository('farmroot',$rfarm);

		

		// domainroot

		$rdomain = new Repository();

		$rdomain->set_location($pmwiki->get_domaindir());

		$rdomain->set_url($pmwiki->get_domainurl());

		$roots->set_repository('domainroot',$rdomain);

		

		// public resources

		$publicresources = new Repository();

		$publicresources->set_resource($pmwiki->get_localpubdir(),$pmwiki->get_localpubdirurl(),'localpublic');

		$publicresources->set_resource($pmwiki->get_farmpubdir(),$pmwiki->get_farmpubdirurl(),'farmpublic');

		$repository->set_repository('publicresources',$publicresources);

		

		// public files

		$pmwiki_uploads = PMW_Uploads::instance();

		$publicfiles = new Repository();

		$publicfiles->set_resource($pmwiki_uploads->get_uploaddir(),$pmwiki_uploads->get_uploadurl(),'uploads');

		$repository->set_repository('publicfiles',$publicfiles);

		

		// set selected page framework

		$this->_selected_framework = $selectedframework = PageFrameworks::instance()->get_selected_framework();

		if (!$selectedframework)

		{

			throw new Exception('PageFramework not set.');

		}

		$selectedframework->prepare_framework();

	}

	

	public function get_repository()

	{

		return $this->_repository;

	}
}