<?php

// factory and cache for PageFramework objects

class PageFrameworks

{

	private static $_instance = NULL;

	public static function instance()
	{
		if (!self::$_instance)
		{

			self::$_instance = new self();
		}

		return self::$_instance;
	}
	private $_frameworks = array();

	private $_framework;

	private $_frameworkname;

	

	protected function __construct() {}

	

	function set_framework($frameworkname)

	{

		if (array_key_exists($frameworkname,$this->_frameworks))

		{

			$this->_framework = $frameworkname;

			return $this->_frameworks[$frameworkname];

		}

		else

		{

			try

			{

				$framework = new $frameworkname();

				$this->_frameworks[$frameworkname] = $framework;

				return $framework;

			}

			catch(Exception $e)

			{

				throw new Exception('PageFramework ' . $frameworkname . ' not found.');

			}

		}

	}

	function get_framework($frameworkname)

	{

		if (array_key_exists($frameworkname,$this->_frameworks))

		{

			return $this->_frameworks[$frameworkname];

		}

		else

		{

			throw new Exception('PageFramework ' . $frameworkname . ' not found.');

		}

	}

	function select_framework($frameworkname)

	{

		if (array_key_exists($frameworkname,$this->_frameworks))

		{

			$this->_framework = $this->_frameworks[$frameworkname];

			$this->_frameworkname = $frameworkname;

		}

		else

		{

			throw new Exception('PageFramework ' . $frameworkname . ' not found.');

		}

	}

	function get_selected_framework()

	{

		return $this->_framework;

	}

	function get_selected_frameworkname()

	{

		return $this->_frameworkname;

	}

}

